# Imports have to be in this order, leave this comment here to fall back to it if they get messed up
# import sc2, sys
# from __init__ import run_ladder_game
# from sc2 import Race, Difficulty
# from sc2.player import Bot, Computer
# import random
import sc2, sys
from __init__ import run_ladder_game
from sc2 import PlayerType, Race, Difficulty, AIBuild
from sc2.player import Bot, Computer, Human, Observer
from sc2.client import Client
from sc2.protocol import ConnectionAlreadyClosed
import random

# Load bot
from Main import Terra

bot = Bot(Race.Protoss, Terra())

# Start game
if __name__ == "__main__":
    if "--LadderServer" in sys.argv:
        # Ladder game started by LadderManager
        print("Starting ladder game...")
        result, opponentid = run_ladder_game(bot)
        print(f"{result} against opponent {opponentid}")
    else:
        # Local game
        print("Starting local game...")
        s2_2018 = random.choice([
                                # "(2)16-BitLE",
                                # "(2)AcidPlantLE",
                                # "(2)CatalystLE",
                                "(2)DreamcatcherLE",
                                "(2)LostandFoundLE",
                                "(2)RedshiftLE",
                                # "(4)DarknessSanctuaryLE"
                                ])
        s3_2018 = random.choice([
                                "(3)AcidPlantLE",
                                "(3)BlueshiftLE",
                                "(3)CeruleanFallLE",
                                "(3)DreamcatcherLE",
                                "(3)FractureLE",
                                "(3)LostAndFoundLE",
                                "(3)ParaSiteLE"
                                ])
        s1_2019 = random.choice([
                                "AutomatonLE",
                                "BlueshiftLE",
                                "CeruleanFallLE",
                                "KairosJunctionLE",
                                "ParaSiteLE",
                                "PortAleksanderLE",
                                # "StasisLE",
                                # "DarknessSanctuaryLE"
                                ])
        s2_2019 = random.choice([
                                "CyberForestLE",
                                "KairosJunctionLE",
                                "KingsCoveLE",
                                "NewRepugnancyLE"
                                ])
        s3_2019 = random.choice([
                                "AcropolisLE",
                                "DiscoBloodbathLE",
                                "EphemeronLE",
                                "ThunderbirdLE",
                                "TritonLE",
                                "WintersGateLE",
                                "WorldofSleepersLE",
                                ])
        # map_name = s2_2018
        # map_name = s3_2018
        # map_name = s4_2018
        # map_name = s2_2019
        map_name = s3_2019
        # map_name = random.choice([s2_2018,s3_2018,s1_2019,s2_2019,s3_2019])
        # map_name = "(2)DreamcatcherLE"

        race = random.choice([
                    sc2.Race.Terran,
                    sc2.Race.Zerg,
                    sc2.Race.Protoss,
                    sc2.Race.Random,
                    ])

        build = random.choice([
                    sc2.AIBuild.RandomBuild,
                    sc2.AIBuild.Rush,
                    sc2.AIBuild.Timing,
                    sc2.AIBuild.Power,
                    sc2.AIBuild.Macro,
                    sc2.AIBuild.Air,
                    ])

        # COMPUTER OPPONENT - Difficulty {  VeryEasy = 1;  Easy = 2;  Medium = 3;  MediumHard = 4;  Hard = 5;  Harder = 6;  VeryHard = 7;  CheatVision = 8;  CheatMoney = 9;  CheatInsane = 10;}
        difficulty = random.choice([
                    Difficulty.VeryHard,
                    # Difficulty.CheatVision,
                    # Difficulty.CheatMoney,
                    # Difficulty.CheatInsane,
                    ])

        opponent_bot = Computer(race,difficulty,build)

        if opponent_bot.type == PlayerType.Computer:
            opponent_bot_race = opponent_bot.race.name
            opponent_bot_difficulty = opponent_bot.difficulty.name
            opponent_bot_build = opponent_bot.ai_build.name
            opponent_bot_name = f'{opponent_bot_race}-{opponent_bot_difficulty}-{opponent_bot_build}'
        else:
            opponent_bot_name = 'SomeOtherBot'

        replay_file_name = f'data/replays/Terra-P-vs-{opponent_bot_name}-{map_name}.SC2Replay'
        print("REPLAY:",replay_file_name)

        # RUN GAME
        result = sc2.run_game(sc2.maps.get(map_name),[
                # Human(Race.Terran),  # if you uncomment Human than comment out opponent_bot below
                bot,
                opponent_bot,
                ],
            realtime=False,  # True
        )

        print(f"{result.name} against opponent {opponent_bot_name} on map {map_name}")
